## sumo 1.4.0+dfsg1

=== CMakeLists.txt ===
# set VERSION to empty string
cmake_policy(SET CMP0048 NEW)
# do not expand quoted variables in if statements
cmake_policy(SET CMP0054 NEW)
# Options
option(CHECK_OPTIONAL_LIBS "Try to download / enable all optional libraries (use only EPL clean libraries, if set to false)" true)
option(MULTITHREADED_BUILD "Use all available cores for building (applies to Visual Studio only)" true)
option(PROFILING "Enable output of profiling data (applies to gcc/clang builds only)" false)
option(COVERAGE "Enable output of coverage data (applies to gcc/clang builds only)" false)
option(SUMO_UTILS "Enable generation of a shared library for the utility functions for option handling, XML parsing etc." false)
set(BINARY_SUFFIX "" CACHE STRING "Append the suffix to every generated binary")
set(COMPILE_DEFINITIONS "" CACHE STRING "Macros or defines to add when compiling")

# Set a default build type if none was specified
# you may use -DCMAKE_BUILD_TYPE:STRING=Debug from the command line
set(default_build_type "Release")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif ()

project(SUMO)
set(PACKAGE_VERSION "1.4.0")
cmake_minimum_required(VERSION 3.1)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/cmake_modules/")

set(ENABLED_FEATURES "${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR} ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")

if (COMPILE_DEFINITIONS)
    add_compile_definitions(${COMPILE_DEFINITIONS})
endif ()

# compiler specific flags
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
    "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -pthread -Wall -pedantic -Wextra")
    set(ENABLED_FEATURES "${ENABLED_FEATURES} ${CMAKE_BUILD_TYPE}")
    if (PROFILING)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
        set(ENABLED_FEATURES "${ENABLED_FEATURES} Profiling")
        set(BINARY_SUFFIX "${BINARY_SUFFIX}P")
    endif ()
    if (COVERAGE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -O0")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
        set(ENABLED_FEATURES "${ENABLED_FEATURES} Coverage")
    endif ()
elseif (MSVC)
    # enabling /WX is not possible due to warnings in external headers
    # /Wall brings MSVC 2013 to complete halt
    if ("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
        # this is a workaround to disable lots of warnings for replacing /W3 with /W4 in VS 2019
        # there is a policy for that starting with CMake 3.15
        string(REPLACE "/W3" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else ()
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /W4")
    endif ()
    if (MULTITHREADED_BUILD)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
    endif ()
    if (MSVC_VERSION GREATER 1919)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /experimental:external /external:W3")
    endif ()
    # exporting symbols for shared libraries needs to enabled explicitly
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif ()

# special debug flags
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=undefined,address,integer,unsigned-integer-overflow -fno-omit-frame-pointer -fsanitize-blacklist=${CMAKE_SOURCE_DIR}/build/clang_sanitize_blacklist.txt")
endif ()

# we need to build position independent code when generating a shared library
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
if (SUMO_UTILS)
    set(ENABLED_FEATURES "${ENABLED_FEATURES} SumoUtilsLibrary")
endif ()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
# force Visual Studio to leave out the Release / Debug dirs
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/bin)
# Debug messages
message(STATUS "CMAKE_BINARY_DIR: " ${CMAKE_BINARY_DIR})
message(STATUS "CMAKE_SOURCE_DIR: " ${CMAKE_SOURCE_DIR})
message(STATUS "")
message(STATUS "Platform: ")
message(STATUS "    Host: " ${CMAKE_HOST_SYSTEM} " " ${CMAKE_HOST_SYSTEM_PROCESSOR})
message(STATUS "    Target: " ${CMAKE_SYSTEM} " " ${CMAKE_SYSTEM_PROCESSOR})
message(STATUS "    CMake: " ${CMAKE_VERSION})
message(STATUS "    CMake generator: " ${CMAKE_GENERATOR})
message(STATUS "    CMake build tool: " ${CMAKE_BUILD_TOOL})
message(STATUS "    Compiler: " ${CMAKE_CXX_COMPILER_ID} " " ${CMAKE_CXX_COMPILER_VERSION})
if (CMAKE_GENERATOR MATCHES Xcode)
    message(STATUS "    Xcode: " ${XCODE_VERSION})
endif ()
message(STATUS "")

#set(Python_ADDITIONAL_VERSIONS 3.7 3.6 3.5 3.4 3.3 2.7) # it may help in finding the correct python for libsumo
find_package(PythonInterp REQUIRED)
message(STATUS "Found Python: " ${PYTHON_EXECUTABLE})
execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import setuptools" RESULT_VARIABLE SETUPTOOLS_MISSING)

#http://stackoverflow.com/questions/1487752/how-do-i-instruct-cmake-to-look-for-libraries-installed-by-macports
if (APPLE)
    link_directories(/opt/X11/lib)
    include_directories(SYSTEM /opt/X11/include)
    # Detect if the "port" command is valid on this system; if so, return full path
    execute_process(COMMAND which port RESULT_VARIABLE DETECT_MACPORTS OUTPUT_VARIABLE MACPORTS_PREFIX ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (${DETECT_MACPORTS} EQUAL 0)
        # MACPORTS_PREFIX contains now something like "/opt/local/bin/port", so we get the parent directory
        get_filename_component(MACPORTS_PREFIX ${MACPORTS_PREFIX} DIRECTORY)
        # "/opt/local" is where MacPorts lives, add `/lib` suffix and link
        link_directories(${MACPORTS_PREFIX}/../lib)
        include_directories(${MACPORTS_PREFIX}/../include)
        message(STATUS "Macports detected: ${MACPORTS_PREFIX}")
    endif ()
    # Recommendation, also add a "brew --prefix" custom command to detect a homebrew build environment
    execute_process(COMMAND brew --prefix RESULT_VARIABLE DETECT_BREW OUTPUT_VARIABLE BREW_PREFIX ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (${DETECT_BREW} EQUAL 0)
        link_directories(${BREW_PREFIX}/lib)
        include_directories(${BREW_PREFIX}/include)
        message(STATUS "Brew detected: ${BREW_PREFIX}")
    endif ()
endif (APPLE)

#  Specifically define variable WIN32 for compilations under windows (due an error in Shawn)
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND WIN32)
    option(USE_MINGW_64BITS "Use 64 bits libraries for the compilation with MinGW" true)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWIN32 -D_WIN32_WINNT=0x0501")
endif ()

# Check if libraries have to be found, depending on SUMO_LIBRARIES
set(SUMO_LIBRARIES "$ENV{SUMO_LIBRARIES}" CACHE PATH "Location of SUMOLibraries dependencies")

# some user place SUMOLibraries in the same SUMO folder
if (NOT SUMO_LIBRARIES AND EXISTS "${CMAKE_SOURCE_DIR}/../SUMOLibraries")
    set(SUMO_LIBRARIES "${CMAKE_SOURCE_DIR}/../SUMOLibraries")
endif ()

# check if SUMOLibraries was found (Only in Windows)
if (SUMO_LIBRARIES AND WIN32)
    # set option for install debug and release runtime dlls
    option(INSTALL_DLL_RUNTIMES "Copy debug and release runtimes for MSVC" true)
    # Special option for MinGW32
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND WIN32)
        if (USE_MINGW_64BITS)
            message(STATUS "Using 64 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES} " for MinGW compilation")
        else()
            message(STATUS "Using 32 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES} " for MinGW compilation")
            # Use 32 bits libraries
            set(LIB_VERSION "/32bits")
            # disable optional libraries
            set(CHECK_OPTIONAL_LIBS false)
        endif ()
    elseif ("${CMAKE_MODULE_LINKER_FLAGS}" STREQUAL "/machine:x64")
        message(STATUS "Using 64 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES})
    else()
        message(STATUS "Using 32 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES})
        # Use 32 bits libraries
        set(LIB_VERSION "/32bits")
        # disable optional libraries
        set(CHECK_OPTIONAL_LIBS false)
    endif ()
    # set Xerces
    if ("${MSVC_VERSION}" STREQUAL "1800")
        # msvc2012 requieres a special version of xerces 
        file(GLOB XERCES_PATH "${SUMO_LIBRARIES}/msvc12${LIB_VERSION}/xerces-c-3.?.?")
    else()
        file(GLOB XERCES_PATH "${SUMO_LIBRARIES}${LIB_VERSION}/xerces-c-3.?.?")
    endif ()
    # set zlib
    file(GLOB ZLIB_PATH "${SUMO_LIBRARIES}${LIB_VERSION}/3rdPartyLibs/zlib-?.?.??")
    # set PROJ and GDAL
    if (EXISTS "${SUMO_LIBRARIES}${LIB_VERSION}/proj_gdal-1911")
        # "proj_gdal-1911" is used by old versions of SUMOLibraries
        file(GLOB PROJ_PATH "${SUMO_LIBRARIES}${LIB_VERSION}/proj_gdal-1911")
        file(GLOB GDAL_PATH "${SUMO_LIBRARIES}${LIB_VERSION}/proj_gdal-1911")
        set(PROJ_6 0)
    elseif ("${MSVC_VERSION}" STREQUAL "1800")
        # msvc2012 requieres a special version of proj_gdal 
        file(GLOB PROJ_PATH "${SUMO_LIBRARIES}/msvc12${LIB_VERSION}/proj_gdal-1911")
        file(GLOB GDAL_PATH "${SUMO_LIBRARIES}/msvc12${LIB_VERSION}/proj_gdal-1911")
        set(PROJ_6 0)
    else()
        # use proj 6 and gdal 3
        file(GLOB PROJ_PATH "${SUMO_LIBRARIES}${LIB_VERSION}/proj-?.?.?")
        file(GLOB GDAL_PATH "${SUMO_LIBRARIES}${LIB_VERSION}/gdal-?.?.?")
        set(PROJ_6 1)
    endif ()
    # set fox
    file(GLOB FOX_PATH "${SUMO_LIBRARIES}${LIB_VERSION}/fox-?.?.??")
    # set all paths in prefix
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${XERCES_PATH};${ZLIB_PATH};${ZLIB_PATH}/Release;${ZLIB_PATH}/Debug;${ZLIB_PATH}/bin;${ZLIB_PATH}/lib;${PROJ_PATH};${GDAL_PATH};${FOX_PATH}")
    # save in variable SUMO_LIBRARIES_DLL all paths to dll files
    file(GLOB SUMO_LIBRARIES_DLL "${XERCES_PATH}/bin/*.dll"
                                 "${PROJ_PATH}/bin/*.dll"
                                 "${FOX_PATH}/lib/*.dll" # used by old SUMOLibraries versions
                                 "${FOX_PATH}/bin/*.dll"
                                 "${ZLIB_PATH}/bin/*.dll"
                                 "${SUMO_LIBRARIES}${LIB_VERSION}/3rdPartyLibs/bzip2-?.?.?/*.dll" # used by old versions of SUMOLibraries
                                 "${SUMO_LIBRARIES}${LIB_VERSION}/3rdPartyLibs/bzip2-?.?.?/bin/*.dll"
                                 "${SUMO_LIBRARIES}${LIB_VERSION}/3rdPartyLibs/libpng-?.?.??/bin/*.dll"
                                 "${SUMO_LIBRARIES}${LIB_VERSION}/3rdPartyLibs/tiff-?.?.?/bin/*.dll"
                                 "${SUMO_LIBRARIES}${LIB_VERSION}/3rdPartyLibs/zlib-?.?.??/bin/*.dll"
                                 "${SUMO_LIBRARIES}${LIB_VERSION}/3rdPartyLibs/sqlite-?.?.?/*.dll")
    # set MSVC dlls
    if ("${MSVC_VERSION}" STREQUAL "1800")
        file(GLOB MSVC_DLLS "${SUMO_LIBRARIES}${LIB_VERSION}/runtimes/*.dll" "${SUMO_LIBRARIES}/msvc12${LIB_VERSION}/runtimes/*.dll")
    else()
        file(GLOB MSVC_DLLS "${SUMO_LIBRARIES}${LIB_VERSION}/runtimes/*.dll")
    endif ()
    # set google test root
    file(GLOB GTEST_ROOT "${SUMO_LIBRARIES}/googletest-?.?.?/googletest")
    # set GoogleTest only if compiler isn't mingw32
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND WIN32 AND NOT USE_MINGW_64BITS)
        message(STATUS "Disabled Google Test in Mingw32")
    else()

=== src/CMakeLists.txt ===
set(netconvertlibs
        netwrite netimport netbuild foreign_eulerspiral ${GDAL_LIBRARY} netimport_vissim netimport_vissim_typeloader netimport_vissim_tempstructs ${commonlibs})

set(sumolibs
        traciserver netload microsim_cfmodels microsim_engine microsim_lcmodels microsim_devices microsim_trigger microsim_output microsim_pedestrians microsim_actions
        microsim_traffic_lights microsim mesosim ${commonvehiclelibs} ${GRPC_LIBS}
        ${PYTHON_LIBRARIES})

add_subdirectory(activitygen)
add_subdirectory(dfrouter)
add_subdirectory(duarouter)
add_subdirectory(foreign)
add_subdirectory(jtrrouter)
add_subdirectory(libsumo)
add_subdirectory(marouter)
add_subdirectory(mesosim)
add_subdirectory(microsim)
add_subdirectory(netbuild)
add_subdirectory(netgen)
add_subdirectory(netimport)
add_subdirectory(netload)
add_subdirectory(netwrite)
add_subdirectory(od)
add_subdirectory(osgview)
add_subdirectory(polyconvert)
add_subdirectory(router)
add_subdirectory(tools)
add_subdirectory(traci-server)
add_subdirectory(traci_testclient)
add_subdirectory(utils)
if (FOX_FOUND)
    add_subdirectory(gui)
    add_subdirectory(guinetload)
    add_subdirectory(guisim)
    add_subdirectory(mesogui)
    add_subdirectory(netedit)
endif ()


add_executable(sumo sumo_main.cpp)
set_target_properties(sumo PROPERTIES OUTPUT_NAME sumo${BINARY_SUFFIX})
set_target_properties(sumo PROPERTIES OUTPUT_NAME_DEBUG sumo${BINARY_SUFFIX}D)
target_link_libraries(sumo microsim traciserver libsumostatic ${sumolibs})
add_dependencies(sumo generate-version-h)

if (FOX_FOUND)
    add_executable(sumo-gui guisim_main.cpp sumo-gui.rc)
    set_target_properties(sumo-gui PROPERTIES OUTPUT_NAME sumo-gui${BINARY_SUFFIX})
    set_target_properties(sumo-gui PROPERTIES OUTPUT_NAME_DEBUG sumo-gui${BINARY_SUFFIX}D)
    target_link_libraries(sumo-gui gui guinetload guisim gui gui_dialogs
        utils_gui_windows utils_gui_globjects utils_gui_div utils_gui_settings
        utils_gui_images utils_gui_cursors utils_gui_shortcuts utils_gui_tracker utils_foxtools osgview microsim traciserver libsumostatic ${sumolibs} mesogui
        ${GDAL_LIBRARY} ${FFMPEG_LIBRARIES} ${OPENSCENEGRAPH_LIBRARIES} ${GL2PS_LIBRARIES})
    if (MSVC)
        set_target_properties(sumo-gui PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS /ENTRY:mainCRTStartup")
        if (FFMPEG_FOUND)
            set_target_properties(sumo-gui PROPERTIES LINK_FLAGS "/SAFESEH:NO")
        endif ()
        target_link_libraries(sumo-gui opengl32 glu32)
    endif ()
    add_dependencies(sumo-gui generate-version-h)
    install(TARGETS sumo-gui RUNTIME DESTINATION bin)
endif ()

add_executable(netconvert netconvert_main.cpp)
set_target_properties(netconvert PROPERTIES OUTPUT_NAME netconvert${BINARY_SUFFIX})
set_target_properties(netconvert PROPERTIES OUTPUT_NAME_DEBUG netconvert${BINARY_SUFFIX}D)
target_link_libraries(netconvert ${netconvertlibs})
add_dependencies(netconvert generate-version-h)

add_executable(od2trips od2trips_main.cpp)
set_target_properties(od2trips PROPERTIES OUTPUT_NAME od2trips${BINARY_SUFFIX})
set_target_properties(od2trips PROPERTIES OUTPUT_NAME_DEBUG od2trips${BINARY_SUFFIX}D)
target_link_libraries(od2trips od utils_vehicle ${commonlibs})
add_dependencies(od2trips generate-version-h)

install(TARGETS sumo netconvert od2trips RUNTIME DESTINATION bin)

configure_file(config.h.cmake config.h)

if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../.git")
    set(VERSION_DEP "${CMAKE_CURRENT_SOURCE_DIR}/../.git")
endif()
add_custom_command(OUTPUT version.h
                   COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/build/version.py ${CMAKE_CURRENT_BINARY_DIR}
                   DEPENDS ${VERSION_DEP}
                  )
add_custom_target(generate-version-h DEPENDS version.h)
set_property(TARGET generate-version-h PROPERTY FOLDER "CMake")

=== src/foreign/CMakeLists.txt ===
add_subdirectory(PHEMlight)
add_subdirectory(rtree)
add_subdirectory(tcpip)
add_subdirectory(eulerspiral)

=== src/jtrrouter/CMakeLists.txt ===
set(jtrrouter_SRCS
   jtrrouter_main.cpp
   ROJTREdge.cpp
   ROJTREdge.h
   ROJTREdgeBuilder.cpp
   ROJTREdgeBuilder.h
   ROJTRRouter.cpp
   ROJTRRouter.h
   ROJTRTurnDefLoader.cpp
   ROJTRTurnDefLoader.h
   ROJTRFrame.cpp
   ROJTRFrame.h
)

add_executable(jtrrouter ${jtrrouter_SRCS})
set_target_properties(jtrrouter PROPERTIES OUTPUT_NAME jtrrouter${BINARY_SUFFIX})
set_target_properties(jtrrouter PROPERTIES OUTPUT_NAME_DEBUG jtrrouter${BINARY_SUFFIX}D)
target_link_libraries(jtrrouter router ${commonvehiclelibs})
add_dependencies(jtrrouter generate-version-h)

install(TARGETS jtrrouter RUNTIME DESTINATION bin)

=== src/libsumo/CMakeLists.txt ===
if (${CMAKE_VERSION} VERSION_GREATER 3.13.0)
    # UseSWIG generates standard target names
    cmake_policy(SET CMP0078 NEW)
endif()
if (${CMAKE_VERSION} VERSION_GREATER 3.14.0)
    # pass module name to swig compiler
    cmake_policy(SET CMP0086 NEW)
endif()
set(libsumostatic_STAT_SRCS
    Edge.cpp
    Edge.h
    Helper.cpp
    Helper.h
    InductionLoop.cpp
    InductionLoop.h
    Junction.cpp
    Junction.h
    Lane.cpp
    Lane.h
    LaneArea.cpp
    LaneArea.h
    MultiEntryExit.h
    MultiEntryExit.cpp
    Person.cpp
    Person.h
    POI.cpp
    POI.h
    Polygon.h
    Polygon.cpp
    Route.h
    Route.cpp
    Simulation.cpp
    Simulation.h
    Subscription.h
    TraCIConstants.h
    TraCIDefs.h
    TrafficLight.cpp
    TrafficLight.h
    Vehicle.cpp
    Vehicle.h
    VehicleType.cpp
    VehicleType.h
)

add_library(libsumostatic STATIC ${libsumostatic_STAT_SRCS})
set_property(TARGET libsumostatic PROPERTY FOLDER "libsumo")

set(ENABLE_PYTHON_BINDINGS ON CACHE BOOL "Build Python Bindings")
set(ENABLE_JAVA_BINDINGS ON CACHE BOOL "Build Java Bindings")

if(SWIG_FOUND)
    include(${SWIG_USE_FILE})
    set_source_files_properties(libsumo.i PROPERTIES CPLUSPLUS ON)
    file(GLOB LIBSUMO_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
    if(ENABLE_JAVA_BINDINGS)
        find_package(Java)
        find_package(JNI)
        if(JAVA_FOUND AND JNI_FOUND)
            include(UseJava)
            include_directories(${JNI_INCLUDE_DIRS})
            set(CMAKE_SWIG_FLAGS -package org.eclipse.sumo.libsumo)
            set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/java)
            set(SWIG_MODULE_libsumojni_EXTRA_DEPS ${LIBSUMO_HEADERS})
            if (${CMAKE_VERSION} VERSION_GREATER 3.8.0)
                SWIG_ADD_LIBRARY(libsumojni LANGUAGE java SOURCES libsumo.i)
            else()
                SWIG_ADD_MODULE(libsumojni java libsumo.i)
            endif()
            if (MSVC OR APPLE)
                swig_link_libraries(libsumojni libsumostatic ${sumolibs})
            else()
                set_source_files_properties(${swig_generated_file_fullname} PROPERTIES COMPILE_FLAGS "-Wno-strict-aliasing")
                swig_link_libraries(libsumojni -Wl,--whole-archive libsumostatic ${sumolibs} -Wl,--no-whole-archive)
            endif()
            FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/classes")
            ADD_CUSTOM_COMMAND(TARGET libsumojni POST_BUILD
                COMMAND "${Java_JAVAC_EXECUTABLE}" -d classes java/*.java
                COMMAND "${Java_JAR_EXECUTABLE}" -cfM ${CMAKE_SOURCE_DIR}/bin/libsumojni.jar -C classes .
                COMMAND "${Java_JAR_EXECUTABLE}" -cfM ${CMAKE_SOURCE_DIR}/bin/libsumojni_src.jar -C java .
            )
            set_property(TARGET libsumojni PROPERTY FOLDER "libsumo")
        else()
            message(WARNING "ENABLE_JAVA_BINDINGS is set but Java or JNI was not found.")
        endif()
    endif()

    find_package(PythonLibs)
    if(ENABLE_PYTHON_BINDINGS)
        if (MSVC)
            # recheck that the platform of the generator and python matches
            execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import sys; print(sys.version)"
                            OUTPUT_VARIABLE PYTHON_FULL_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
            string(FIND ${PYTHON_FULL_VERSION} "64 bit" IS_PYTHON64)
            if(${CMAKE_MODULE_LINKER_FLAGS} STREQUAL "/machine:x64" AND ${IS_PYTHON64} EQUAL -1)
                message(STATUS "Did not find Python 64 bit. Please set PYTHON_EXECUTABLE, PYTHON_INCLUDE_DIR and PYTHON_LIBRARY manually.")
                set(PYTHONLIBS_FOUND OFF)
            endif()
        endif()
        if(PYTHONLIBS_FOUND)
            if (PYTHON_DEBUG_LIBRARY OR NOT "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
                include_directories(${PYTHON_INCLUDE_PATH})
#                set(CMAKE_SWIG_FLAGS "")
                set(CMAKE_SWIG_FLAGS "-keyword") # is necessary for using keyword args, but generates lots of warnings
# other options which should be evaluated: -builtin, -modern, -extranative
                set(CMAKE_SWIG_OUTDIR ${CMAKE_SOURCE_DIR}/tools/libsumo)
                set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/tools/libsumo)
                set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/tools/libsumo)
                set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/tools/libsumo)
                set(SWIG_MODULE_libsumo_EXTRA_DEPS ${LIBSUMO_HEADERS})
                if (${CMAKE_VERSION} VERSION_GREATER 3.8.0)
                    SWIG_ADD_LIBRARY(libsumo LANGUAGE python SOURCES libsumo.i)
                else()
                    SWIG_ADD_MODULE(libsumo python libsumo.i)
                endif()
                if (MSVC OR APPLE)
                    # disable python module for the debug build because virtually no one has a python debug dll to link against
                    set_property(TARGET ${SWIG_MODULE_libsumo_REAL_NAME} PROPERTY EXCLUDE_FROM_DEFAULT_BUILD_DEBUG TRUE)
                    set_property(TARGET ${SWIG_MODULE_libsumo_REAL_NAME} PROPERTY FOLDER "libsumo")
                    swig_link_libraries(libsumo libsumostatic ${sumolibs} ${PYTHON_LIBRARIES})
                else()
                    swig_link_libraries(libsumo -Wl,--whole-archive libsumostatic ${sumolibs} -Wl,--no-whole-archive ${PYTHON_LIBRARIES})
                endif()
                if (NOT ${SETUPTOOLS_MISSING})
                    install(
                        CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/build/setup-libsumo.py clean --all install --root=\$ENV{DESTDIR}/ --prefix=${CMAKE_INSTALL_PREFIX} --optimize=1)"
                        COMPONENT pylibsumo)
                endif()
            endif()
        else()
            message(WARNING "ENABLE_PYTHON_BINDINGS is set but python libraries were not found.")
        endif()
    endif()

endif()

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/bin)
add_library(libsumoc SHARED ${libsumostatic_STAT_SRCS})
set_property(TARGET libsumoc PROPERTY FOLDER "libsumo")
set_target_properties(libsumoc PROPERTIES PREFIX "")
install(TARGETS libsumoc DESTINATION ${CMAKE_INSTALL_LIBDIR})
if (MSVC OR APPLE)
    target_link_libraries(libsumoc PRIVATE ${sumolibs})
else ()
    target_link_libraries(libsumoc PRIVATE -Wl,--whole-archive ${sumolibs} -Wl,--no-whole-archive)
endif()

=== src/marouter/CMakeLists.txt ===
set(marouter_SRCS
   marouter_main.cpp
   ROMAAssignments.cpp
   ROMAAssignments.h
   ROMAEdge.cpp
   ROMAEdge.h
   ROMAEdgeBuilder.cpp
   ROMAEdgeBuilder.h
   ROMAFrame.cpp
   ROMAFrame.h
   ROMARouteHandler.cpp
   ROMARouteHandler.h
)

add_executable(marouter ${marouter_SRCS})
set_target_properties(marouter PROPERTIES OUTPUT_NAME marouter${BINARY_SUFFIX})
set_target_properties(marouter PROPERTIES OUTPUT_NAME_DEBUG marouter${BINARY_SUFFIX}D)
target_link_libraries(marouter router od ${commonvehiclelibs})
add_dependencies(marouter generate-version-h)

install(TARGETS marouter RUNTIME DESTINATION bin)

=== src/microsim/CMakeLists.txt ===
add_subdirectory(actions)
add_subdirectory(cfmodels)
add_subdirectory(devices)
add_subdirectory(engine)
add_subdirectory(lcmodels)
add_subdirectory(logging)
add_subdirectory(output)
add_subdirectory(pedestrians)
add_subdirectory(traffic_lights)
add_subdirectory(trigger)

set(microsim_STAT_SRCS
   MSBitSetLogic.h
   MSBaseVehicle.cpp
   MSBaseVehicle.h
   MSCModel_NonInteracting.h
   MSCModel_NonInteracting.cpp
   MSContainer.cpp
   MSContainer.h
   MSEdge.cpp
   MSEdge.h
   MSEdgeControl.cpp
   MSEdgeControl.h
   MSEdgeWeightsStorage.cpp
   MSEdgeWeightsStorage.h
   MSEventControl.cpp
   MSEventControl.h
   MSDynamicShapeUpdater.cpp
   MSDynamicShapeUpdater.h
   MSFrame.cpp
   MSFrame.h
   MSGlobals.cpp
   MSGlobals.h
   MSInsertionControl.cpp
   MSInsertionControl.h
   MSInternalJunction.cpp
   MSInternalJunction.h
   MSJunction.cpp
   MSJunction.h
   MSJunctionControl.cpp
   MSJunctionControl.h
   MSJunctionLogic.cpp
   MSJunctionLogic.h
   MSLane.cpp
   MSLane.h
   MSLaneChanger.cpp
   MSLaneChanger.h
   MSLaneChangerSublane.cpp
   MSLaneChangerSublane.h
   MSLink.cpp
   MSLink.h
   MSLinkCont.cpp
   MSLinkCont.h
   MSLogicJunction.cpp
   MSLogicJunction.h
   MSMoveReminder.cpp
   MSMoveReminder.h
   MSNet.cpp
   MSNet.h
   MSNoLogicJunction.cpp
   MSNoLogicJunction.h
   MSRightOfWayJunction.cpp
   MSRightOfWayJunction.h
   MSRoute.cpp
   MSRoute.h
   MSRouteHandler.cpp
   MSRouteHandler.h
   MSStoppingPlace.cpp
   MSStoppingPlace.h
   MSParkingArea.cpp
   MSParkingArea.h
   MSVehicle.cpp
   MSVehicle.h
   MSLeaderInfo.cpp
   MSLeaderInfo.h
   MSVehicleContainer.cpp
   MSVehicleContainer.h
   MSVehicleControl.cpp
   MSVehicleControl.h
   MSVehicleTransfer.cpp
   MSVehicleTransfer.h
   MSVehicleType.cpp
   MSVehicleType.h
   MSStateHandler.h
   MSStateHandler.cpp
   MSDriverState.h
   MSDriverState.cpp
   MSTransportable.h
   MSTransportable.cpp
   MSTransportableControl.h
   MSTransportableControl.cpp
)

add_library(microsim STATIC ${microsim_STAT_SRCS})
add_dependencies(microsim generate-version-h)
set_property(TARGET microsim PROPERTY PROJECT_LABEL "z_microsim")

=== src/netedit/CMakeLists.txt ===
add_subdirectory(additionals)
add_subdirectory(changes)
add_subdirectory(dialogs)
add_subdirectory(frames)
add_subdirectory(netelements)
add_subdirectory(demandelements)

set(netedit_SRCS
   netedit_main.cpp
   GNEApplicationWindow.h
   GNEApplicationWindow.cpp
   GNELoadThread.h
   GNELoadThread.cpp
   GNENet.h
   GNENet.cpp
   GNEViewNet.h
   GNEViewNet.cpp
   GNEViewNetHelper.h
   GNEViewNetHelper.cpp
   GNEViewParent.h
   GNEViewParent.cpp
   GNEUndoList.h
   GNEUndoList.cpp
   GNEAttributeCarrier.h
   GNEAttributeCarrier.cpp
   GNEGeometry.h
   GNEGeometry.cpp
   GNEHierarchicalParentElements.h
   GNEHierarchicalParentElements.cpp
   GNEHierarchicalChildElements.h
   GNEHierarchicalChildElements.cpp
   GNEReferenceCounter.h
   GNEEvent_NetworkLoaded.h
)

add_executable(netedit ${netedit_SRCS} netedit.rc)
set_target_properties(netedit PROPERTIES OUTPUT_NAME netedit${BINARY_SUFFIX})
set_target_properties(netedit PROPERTIES OUTPUT_NAME_DEBUG netedit${BINARY_SUFFIX}D)
target_link_libraries(netedit utils_gui_cursors utils_gui_shortcuts 
        utils_foxtools foreign_eulerspiral netedit_frames
        netedit_netelements netedit_demandelements netedit_changes utils_gui_div
        utils_gui_settings utils_gui_images netedit_additionals netedit_dialogs
        utils_gui_windows utils_gui_globjects utils_gui_tracker utils_foxtools utils_vehicle utils_emissions foreign_phemlight ${netconvertlibs} ${FOX_LIBRARY} ${GL2PS_LIBRARIES})
if (MSVC)
    set_target_properties(netedit PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS /ENTRY:mainCRTStartup")
    target_link_libraries(netedit opengl32 glu32)
endif ()
add_dependencies(netedit generate-version-h)

install(TARGETS netedit RUNTIME DESTINATION bin)

=== src/netimport/CMakeLists.txt ===
add_subdirectory(vissim)

set(netimport_STAT_SRCS
   NIFrame.cpp
   NIFrame.h
   NILoader.cpp
   NILoader.h
   NITypeLoader.cpp
   NITypeLoader.h
   NIImporter_ArcView.cpp
   NIImporter_ArcView.h
   NIImporter_DlrNavteq.cpp
   NIImporter_DlrNavteq.h
   NIImporter_ITSUMO.cpp
   NIImporter_ITSUMO.h
   NIImporter_MATSim.cpp
   NIImporter_MATSim.h
   NIImporter_OpenDrive.cpp
   NIImporter_OpenDrive.h
   NIImporter_OpenStreetMap.cpp
   NIImporter_OpenStreetMap.h
   NIImporter_RobocupRescue.cpp
   NIImporter_RobocupRescue.h
   NIImporter_SUMO.cpp
   NIImporter_SUMO.h
   NIImporter_VISUM.cpp
   NIImporter_VISUM.h
   NIVisumTL.cpp
   NIVisumTL.h
   NIXMLConnectionsHandler.cpp
   NIXMLConnectionsHandler.h
   NIXMLEdgesHandler.cpp
   NIXMLEdgesHandler.h
   NIXMLNodesHandler.cpp
   NIXMLNodesHandler.h
   NIXMLTypesHandler.cpp
   NIXMLTypesHandler.h
   NIXMLPTHandler.cpp
   NIXMLPTHandler.h
   NIXMLShapeHandler.cpp
   NIXMLShapeHandler.h
   NIXMLTrafficLightsHandler.cpp
   NIXMLTrafficLightsHandler.h
   NINavTeqHelper.cpp
   NINavTeqHelper.h
   typemap.h
)

add_library(netimport STATIC ${netimport_STAT_SRCS})
set_property(TARGET netimport PROPERTY PROJECT_LABEL "z_netimport")

file(GLOB TYPEMAP_DATA "${CMAKE_CURRENT_SOURCE_DIR}/../../data/typemap/*.typ.xml")
add_custom_command(OUTPUT typemap.h
                   COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/build/typemap.py ${CMAKE_CURRENT_BINARY_DIR}/..
                   DEPENDS ${TYPEMAP_DATA}
                   )

=== src/polyconvert/CMakeLists.txt ===
set(polyconvert_SRCS
   polyconvert_main.cpp
   PCLoaderArcView.cpp
   PCLoaderArcView.h
   PCLoaderDlrNavteq.cpp
   PCLoaderDlrNavteq.h
   PCLoaderVisum.cpp
   PCLoaderVisum.h
   PCLoaderOSM.cpp
   PCLoaderOSM.h
   PCLoaderXML.cpp
   PCLoaderXML.h
   PCNetProjectionLoader.cpp
   PCNetProjectionLoader.h
   PCPolyContainer.cpp
   PCPolyContainer.h
   PCTypeDefHandler.cpp
   PCTypeDefHandler.h
   PCTypeMap.cpp
   PCTypeMap.h
   pc_typemap.h
)

add_executable(polyconvert ${polyconvert_SRCS})
set_target_properties(polyconvert PROPERTIES OUTPUT_NAME polyconvert${BINARY_SUFFIX})
set_target_properties(polyconvert PROPERTIES OUTPUT_NAME_DEBUG polyconvert${BINARY_SUFFIX}D)
target_link_libraries(polyconvert ${commonlibs} ${GDAL_LIBRARY})
add_dependencies(polyconvert generate-version-h)

add_custom_command(OUTPUT pc_typemap.h
                   COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/build/typemap.py ${CMAKE_BINARY_DIR}/src
                   )
set_source_files_properties(${CMAKE_BINARY_DIR}/src/polyconvert/pc_typemap.h PROPERTIES GENERATED TRUE)

install(TARGETS polyconvert RUNTIME DESTINATION bin)

=== src/traci-server/CMakeLists.txt ===
SET(traciserver_STAT_SRCS
   TraCIServer.h
   TraCIServer.cpp
   TraCIServerAPI_Edge.h
   TraCIServerAPI_Edge.cpp
   TraCIServerAPI_InductionLoop.h
   TraCIServerAPI_InductionLoop.cpp
   TraCIServerAPI_Junction.h
   TraCIServerAPI_Junction.cpp
   TraCIServerAPI_Lane.h
   TraCIServerAPI_Lane.cpp
   TraCIServerAPI_MultiEntryExit.h
   TraCIServerAPI_MultiEntryExit.cpp
   TraCIServerAPI_LaneArea.h
   TraCIServerAPI_LaneArea.cpp
   TraCIServerAPI_Person.h
   TraCIServerAPI_Person.cpp
   TraCIServerAPI_POI.h
   TraCIServerAPI_POI.cpp
   TraCIServerAPI_Polygon.h
   TraCIServerAPI_Polygon.cpp
   TraCIServerAPI_Route.h
   TraCIServerAPI_Route.cpp
   TraCIServerAPI_Simulation.h
   TraCIServerAPI_Simulation.cpp
   TraCIServerAPI_TrafficLight.h
   TraCIServerAPI_TrafficLight.cpp
   TraCIServerAPI_Vehicle.h
   TraCIServerAPI_Vehicle.cpp
   TraCIServerAPI_VehicleType.h
   TraCIServerAPI_VehicleType.cpp
)

add_library(traciserver STATIC ${traciserver_STAT_SRCS})
set_property(TARGET traciserver PROPERTY PROJECT_LABEL "z_traciserver")
add_dependencies(traciserver generate-version-h)

=== src/utils/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(distribution)
add_subdirectory(emissions)
add_subdirectory(geom)
add_subdirectory(importio)
add_subdirectory(iodevices)
add_subdirectory(options)
add_subdirectory(shapes)
add_subdirectory(router)
add_subdirectory(traci)
add_subdirectory(vehicle)
add_subdirectory(xml)
if (FOX_FOUND)
    add_subdirectory(foxtools)
    add_subdirectory(gui)
endif ()

if (SUMO_UTILS)
    set(utillibs utils_distribution utils_shapes utils_options utils_xml
        utils_geom utils_common utils_importio utils_iodevices foreign_tcpip ${PROJ_LIBRARY})
    file(WRITE empty.cpp "")
    add_library(sumoutils SHARED empty.cpp)
    install(TARGETS sumoutils DESTINATION lib)
    if (MSVC)
        target_link_libraries(sumoutils ${utillibs} ws2_32)
    elseif (APPLE)
        target_link_libraries(sumoutils ${utillibs})
    else ()
        target_link_libraries(sumoutils -Wl,--whole-archive ${utillibs} -Wl,--no-whole-archive)
    endif()
endif()

=== debian/changelog ===
sumo (1.4.0+dfsg1-1) unstable; urgency=medium

  * [cfb6793] New upstream version 1.4.0+dfsg1
  * [55b1f2f] Refresh patches
  * [9f7b1a6] Remove libxerces-c2-dev from build-depends
  * [262513e] Set upstream metadata fields:
              Bug-Submit, Repository, Repository-Browse.
  * [1a77a39] Remove python from depends in sumo-tools. (Closes: #948931)
  * [1826942] Suppress python-script-but-no-python-dep lintian warning
              (should be clarified with upstream)
  * [70c62c4] Exclude min.js files
  * [c025637] Exclude some more files from the tarball
  * [fad823b] Add +dfsg1 suffix
  * [1c5a8e7] Update d/copyright

 -- Anton Gladky <gladk@debian.org>  Thu, 16 Jan 2020 22:12:23 +0100

sumo (1.3.1-5) unstable; urgency=medium

  * [12e5965] Set SUMO_HOME to escape network usage during build.
              (Closes: #945343)
  * [33f60f2] Let autopkgtests be built without network
  * [fd3c58c] Set Standards-Version to 4.4.1
  * [89e5a7f] Set upstream metadata fields: Repository.

 -- Anton Gladky <gladk@debian.org>  Sat, 23 Nov 2019 20:02:54 +0100

sumo (1.3.1-4) unstable; urgency=medium

  * [a8daad4] Fix some lintian warnings/errors

 -- Anton Gladky <gladk@debian.org>  Wed, 02 Oct 2019 22:56:52 +0200

sumo (1.3.1-3) unstable; urgency=medium

  * [bea99fe] Use python3 instead of python2. (Closes: #938597)

 -- Anton Gladky <gladk@debian.org>  Mon, 30 Sep 2019 22:01:23 +0200

sumo (1.3.1-2) unstable; urgency=medium

  [ Anton Gladky ]
  * [4471ca1] Remove Build-Depends-Indep section

  [ Wookey ]
  * [b28a361] Clean docs after build. (Closes: #925273)
  * [eddc3af] Do not clean  webWizard index.html. (Closes: #925272)

 -- Anton Gladky <gladk@debian.org>  Mon, 30 Sep 2019 17:16:50 +0200

sumo (1.3.1-1) unstable; urgency=medium

  * [93410cf] Update d/copyright
  * [3768348] Update d/watch
  * [443a78d] Refresh patches
  * [bb26543] Minor update in d-files
  * [26cd9ee] Move test-file into the d/tests
  * [6b981ec] Update autopkgtests
  * [a444fea] Set compat-level to 12
  * [aaa2b7e] Set Standards-version to 4.4.0
  * [483bcb4] Remove obsolete fields Name from debian/upstream/metadata.
  * [38f14bd] Update d/upstream/metadata
  * [bf6aeec] New upstream version 1.3.1. (Closes: #931940)

 -- Anton Gladky <gladk@debian.org>  Mon, 30 Sep 2019 15:19:20 +0200

=== debian/control ===
Source: sumo
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               freeglut3-dev,
               help2man,
               libbz2-dev,
               libcups2-dev,
               libfox-1.6-dev,
               libgdal-dev,
               libgl2ps-dev,
               libproj-dev,
               libxerces-c-dev,
               libxrandr-dev,
               python3-minimal
Build-Depends-Indep: doxygen
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/science-team/sumo
Vcs-Git: https://salsa.debian.org/science-team/sumo.git
Homepage: http://sumo.dlr.de/

Package: sumo
Architecture: any
Depends: ${misc:Depends},
         fonts-roboto-unhinted,
         ${shlibs:Depends}
Recommends: sumo-tools
Description: Simulation of Urban MObility (SUMO)
 SUMO is an open source,
 highly portable, microscopic road traffic simulation package
 designed to handle large road networks.
 Main binary.

Package: sumo-doc
Architecture: all
Section: doc
Depends: libjs-underscore,
         ${misc:Depends}
Recommends: sumo
Description: Simulation of Urban MObility (SUMO), documentation and examples
 SUMO is an open source,
 highly portable, microscopic road traffic simulation package
 designed to handle large road networks.
 The binary contatins documentation and examples.

Package: sumo-tools
Architecture: all
Depends: jarwrapper,
         libjs-openlayers,
         python3,
         ${misc:Depends}
Recommends: sumo
Description: Simulation of Urban MObility (SUMO), tools and scripts
 SUMO is an open source,
 highly portable, microscopic road traffic simulation package
 designed to handle large road networks.
 The binary contatins different tools and scripts.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

no_hardening_all_archs = mips mipsel

ifeq (,$(filter $(DEB_HOST_ARCH),$(no_hardening_all_archs)))
  export DEB_BUILD_MAINT_OPTIONS = hardening=+all
endif

DPKG_EXPORT_BUILDFLAGS = 1

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export LIBS := -lgl2ps -lGL -lGLU -lglut

include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:
	dh_auto_configure -- --prefix=/usr

override_dh_auto_build-indep:
	$(MAKE) doxygen

override_dh_auto_build-arch:
	dh_auto_build -a
	$(MAKE) man

override_dh_auto_install:
	sed -i 's/http\:\/\/www\.openlayers\.org\/api\//\/usr\/share\/javascript\/openlayers/g' $(CURDIR)/tools/webWizard/index.html
	dh_auto_install
	find . -type d -name "__pycache__" -delete

override_dh_auto_test-arch:
	mkdir $(CURDIR)/tests_auto
	cd $(CURDIR)/tests_auto; cp $(CURDIR)/debian/tests/hokkaido/* ./; SUMO_HOME=$(CURDIR) ../bin/sumo -b 0 -e 10000 -n net.net.xml -r input_routes.rou.xml --summary-output sum.out
	cat $(CURDIR)/tests_auto/sum.out
	rm -rf $(CURDIR)/tests_auto

=== debian/tests/control ===
Tests: hokk
Depends: sumo

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg1,dversionmangle=s/\.dfsg//,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
     https://github.com/eclipse/sumo/tags .*/v?(\d\S+)\.tar\.gz

## sumo 1.8.0%2Bdfsg2

=== src/netedit/changes/CMakeLists.txt ===
set(netedit_changes_SRCS
   GNEChange.h
   GNEChange.cpp
   GNEChange_Junction.h
   GNEChange_Junction.cpp
   GNEChange_Edge.h
   GNEChange_Edge.cpp
   GNEChange_EdgeType.h
   GNEChange_EdgeType.cpp
   GNEChange_LaneType.h
   GNEChange_LaneType.cpp
   GNEChange_Crossing.h
   GNEChange_Crossing.cpp
   GNEChange_Lane.h
   GNEChange_Lane.cpp
   GNEChange_Connection.h
   GNEChange_Connection.cpp
   GNEChange_Attribute.h
   GNEChange_Attribute.cpp
   GNEChange_EnableAttribute.h
   GNEChange_EnableAttribute.cpp
   GNEChange_TLS.h
   GNEChange_TLS.cpp
   GNEChange_Additional.h
   GNEChange_Additional.cpp
   GNEChange_DemandElement.h
   GNEChange_DemandElement.cpp
   GNEChange_DataSet.h
   GNEChange_DataSet.cpp
   GNEChange_DataInterval.h
   GNEChange_DataInterval.cpp
   GNEChange_GenericData.h
   GNEChange_GenericData.cpp
   GNEChange_Shape.h
   GNEChange_Shape.cpp
   GNEChange_TAZElement.h
   GNEChange_TAZElement.cpp
   GNEChange_Children.h
   GNEChange_Children.cpp
   )

add_library(netedit_changes STATIC ${netedit_changes_SRCS})
set_property(TARGET netedit_changes PROPERTY PROJECT_LABEL "z_netedit_changes")

=== unittest/src/microsim/CMakeLists.txt ===
add_executable(testmicrosim
        MSEventControlTest.cpp
        MSCFModelTest.cpp
        MSCFModel_IDMTest.cpp
        )
set_property(TARGET testmicrosim PROPERTY FOLDER "test_exe")
add_test(testmicrosim ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/testmicrosim)

if (MSVC OR APPLE)
    target_link_libraries(testmicrosim microsim microsim_actions microsim_devices microsim_cfmodels microsim_lcmodels microsim_transportables microsim_trigger microsim_traffic_lights mesosim traciserver libsumostatic netload microsim_output microsim_engine mesosim ${commonvehiclelibs} ${GTEST_BOTH_LIBRARIES})
else ()
    target_link_libraries(testmicrosim -Wl,--start-group microsim microsim_actions microsim_devices microsim_cfmodels microsim_lcmodels microsim_transportables microsim_trigger microsim_traffic_lights mesosim traciserver libsumostatic netload microsim_output microsim_engine mesosim ${commonvehiclelibs} -Wl,--end-group ${GTEST_BOTH_LIBRARIES})
endif ()

=== src/netedit/frames/common/CMakeLists.txt ===
set(netedit_frames_common_SRCS
   GNEInspectorFrame.h
   GNEInspectorFrame.cpp
   GNESelectorFrame.h
   GNESelectorFrame.cpp
   GNEDeleteFrame.h
   GNEDeleteFrame.cpp
   GNEMoveFrame.h
   GNEMoveFrame.cpp
   )

add_library(netedit_frames_common STATIC ${netedit_frames_common_SRCS})
set_property(TARGET netedit_frames_common PROPERTY PROJECT_LABEL "z_netedit_frames_common")
